Subject: Re: [sfc] Please voice your vote in SFC WG to make the zero or more Variable SFC header as the MUST and cisco's 16 bytes context header as "SHOULD" or optional

From: Qin Wu <[email-masked]>
Date: Thu, 19 Nov 2015 03:07:27 +0000

+1, it is not clear to me why 4 context headers MUST be required for MD-TYPE 1,
It looks more flexible to have variable length context header for MD-TYPE 2.

-Qin
From: Linda Dunbar
Sent: Wednesday, November 18, 2015 5:42 PM
To: [email-masked]'; 'Paul Quinn (paulq)'; 'Elzur, Uri'
Subject: draft-ietf-sfc-nsf-01: It makes more sense to state "MD-type = 0x2" (zero or more Variable) as "MUST" and MD-type=0x1" as " SHOULD"

Paul and Uri,

The Section 3.2 of  draft-ietf-sfc-nsf-01 says:

As both MD-type 1 and MD-type 2 are specified by the draft, a more reasonable approach is having the minimum common part (i.e. the first 8 bytes) as the MUST. As the MD-TYPE 2 allows minimum 0 context header (or 16 bytes context header), the MD-TYPE 2 should be a MUST support. And MD-TYPE 1 is a "SHOULD" support.

Let's face it, the majority of SFC deployment probably won't need the all 16 bytes "context header" (which has higher chance of packet fragmentation).

Linda

---

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Thu, 19 Nov 2015 15:38:03 +0000

Qin,

I’m trying to understand the Subject header on this email.

I’ll let the chairs jump in, but there’s no “vote” I believe in the SFC WG. There’s also not “cisco’s context header”. Care to explain?

Linda,

You asked before:

> If an implementation supports MD-Type = 0x2, then it is not supporting MD-Type = 0x1. So what does it mean by saying "Must Support"?

An implementation is able to support both. It is not that if an implementation supports MD-Type 2, it is not supporting MD-Type 1. Only one would be used for a given SFP, but that’s a different question.

Please see inline, my additional $0.02.

> On Nov 18, 2015, at 10:07 PM, Qin Wu <[email-masked]> wrote:
> 
> To: [email-masked] <mailto:[email-masked]>'; 'Paul Quinn (paulq)'; 'Elzur, Uri'
> As both MD-type 1 and MD-type 2 are specified by the draft, a more reasonable approach is having the minimum common part (i.e. the first 8 bytes) as the MUST. As the MD-TYPE 2 allows minimum 0 context header (or 16 bytes context header), the MD-TYPE 2 should be a MUST support. And MD-TYPE 1 is a “SHOULD” support.
> 

The different MD-Types are optimizing different things: MD-Type 1 for performance and HW, MD-Type 2 for flexibility. The idea is that the more we can use fixed headers the better, as getting too creative with the amount of metadata can be a bug more than a feature.

> Let’s face it, the majority of SFC deployment probably won’t need the all 16 bytes "context header" (which has higher chance of packet fragmentation).

This logic seems to argue for MD-Type 1. Prioritizing smaller context metadata, in a performance-friendly way.

Thanks,

— Carlos.

> 
> 
> Linda
> _______________________________________________
> sfc mailing list
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/sfc <https://www.ietf.org/mailman/listinfo/sfc>

---

From: "Paul Quinn (paulq)" <[email-masked]>
Date: Thu, 19 Nov 2015 22:01:06 +0000

Qin,

I've updated to the subject line to reflect the topic more accurately.  Referring to "cisco" context headers is misleading, and frankly indicates a lack of understanding of how a document is adopted.

Further, and I'm sure the chairs will weigh in, but as an IETF participants, you should know that IETF procedure is _not_ vote based.  The NSH draft was adopted based on working group consensus, and as such received significant review.  Similarly, consensus is required for updates.   Please read RFC2418, section 3.3 in particular.

On Nov 18, 2015, at 10:07 PM, Qin Wu <[email-masked]<mailto:[email-masked]>> wrote:

This was discussed on list, prior to adoption, please feel free to review the archives.  In summary, parsing TLVs is a complex operation, particularly in hardware, and as such, a simple fixed header provided an easy to implement metadata solution.  The TLV option is there as well but since the simplest case is needed as a minimum, that is the mandatory piece.  Adding TLV support (i.e. a flexible parser) means you can probably support type-1 as well so the MUST/SHOULD does not create an added burden.

-Qin
From: Linda Dunbar
Sent: Wednesday, November 18, 2015 5:42 PM
To: [email-masked]<mailto:[email-masked]>'; 'Paul Quinn (paulq)'; 'Elzur, Uri'
Subject: draft-ietf-sfc-nsf-01: It makes more sense to state "MD-type = 0x2" (zero or more Variable) as "MUST" and MD-type=0x1" as " SHOULD"

Paul and Uri,

Linda

---

From: Qin Wu <[email-masked]>
Date: Fri, 20 Nov 2015 01:37:15 +0000

Hi,  Carlos:
Sorry for the confusing title, thanks for clarification, I have fixed the title.
I haven’t following the history discussion regarding NSH in the ML, so if my question has been discussed before,
Sorry about repeating this question. I agree fixed header is a good choice from performance perspective, but why 4 context header?

-Qin
发件人: Carlos Pignataro (cpignata) [mailto:[email-masked]]
发送时间: 2015年11月19日 23:38
收件人: Qin Wu
抄送: [email-masked]; Paul Quinn (paulq); [email-masked]; Linda Dunbar
主题: Re: [sfc] NSH context headers: fixed/tlv
Qin,

Linda,

You asked before:

-Qin
From: Linda Dunbar

Paul and Uri,

Thanks,

— Carlos.

Linda
_______________________________________________
sfc mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/sfc